svn commit: r341318 - user/pho/stress2/misc
Peter Holm
pho at FreeBSD.org
Fri Nov 30 07:09:36 UTC 2018
Author: pho
Date: Fri Nov 30 07:09:29 2018
New Revision: 341318
URL: https://svnweb.freebsd.org/changeset/base/341318
Log:
Added a regression test for r340343 "Allow absolute paths for O_BENEATH".
Sponsored by: Dell EMC Isilon
Added:
user/pho/stress2/misc/beneath2.sh (contents, props changed)
Added: user/pho/stress2/misc/beneath2.sh
==============================================================================
--- /dev/null 00:00:00 1970 (empty, because file is newly added)
+++ user/pho/stress2/misc/beneath2.sh Fri Nov 30 07:09:29 2018 (r341318)
@@ -0,0 +1,102 @@
+#!/bin/sh
+
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2018 Dell EMC Isilon
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# O_BENEATH test with a relative path, which is a symbolic link pointing
+# to an absolute path.
+
+# "panic: Assertion (ndp->ni_lcf & NI_LCF_LATCH) != 0 failed at
+# ../../../kern/vfs_lookup.c:182" seen. Fixed by r340343.
+
+# Based on scenario by Vladimir Kondratyev <vladimir kondratyev su>
+
+. ../default.cfg
+[ `id -u` -ne 0 ] && echo "Must be root!" && exit 1
+
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/$0 > $dir/beneath2.c
+mycc -o beneath2 -Wall -Wextra -O0 -g beneath2.c || exit 1
+rm -f beneath2.c
+cd $odir
+
+set -e
+mount | grep "on $mntpoint " | grep -q /dev/md && umount -f $mntpoint
+[ -c /dev/md$mdstart ] && mdconfig -d -u $mdstart
+mdconfig -a -t swap -s 1g -u $mdstart
+bsdlabel -w md$mdstart auto
+newfs $newfs_flags md${mdstart}$part > /dev/null
+mount /dev/md${mdstart}$part $mntpoint
+set +e
+
+cd $mntpoint
+ln -s /tmp/justalongname symlink
+$dir/beneath2 symlink
+s=$?
+[ -f beneath2.core -a $s -eq 0 ] &&
+ { ls -l beneath2.core; mv beneath2.core $dir; s=1; }
+cd $odir
+
+for i in `jot 6`; do
+ mount | grep -q "on $mntpoint " || break
+ umount $mntpoint && break || sleep 10
+ [ $i -eq 6 ] &&
+ { echo FATAL; fstat -mf $mntpoint; exit 1; }
+done
+mdconfig -d -u $mdstart
+rm -rf $dir/beneath2
+exit $s
+
+EOF
+#include <sys/types.h>
+
+#include <err.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+int
+main(int argc, char *argv[])
+{
+ int fd;
+ char *file;
+
+ if (argc != 2) {
+ fprintf(stderr, "Usage: %s <file>", argv[0]);
+ exit(1);
+ }
+ file = argv[1];
+ if ((fd = open(file, O_RDONLY | O_BENEATH)) != 0 && errno != ENOENT)
+ err(1, "open(%s)", file);
+
+ return (0);
+}
More information about the svn-src-user
mailing list